
ChiliProject - Bug # 262: Fix line endings

Status: Closed Priority: Normal
Author: Eric Thomas Category: Refactoring
Created: 2011-03-05 Assignee: Eric Davis
Updated: 2011-05-29 Due date:
Remote issue URL:
Affected version:
Description: "Background":http://help.github.com/dealing-with-lineendings/

Upon doing a fresh clone of the chiliproject git repo, git reports many files as being changed when 
@core.autocrlf@ is set to true.

<pre>
git clone git://github.com/chiliproject/chiliproject.git
git status
# On branch master
# Changed but not updated:
#   (use "git add <file>..." to update what will be committed)
#   (use "git checkout -- <file>..." to discard changes in working directory)
#
#	modified:   app/views/common/error.html.erb
#	modified:   app/views/projects/settings/_activities.rhtml
#	modified:   config/locales/en-GB.yml
#	modified:   config/locales/eu.yml
#	modified:   config/locales/lv.yml
#	modified:   config/locales/mk.yml
#	modified:   config/locales/mn.yml
....
...
..
</pre>

This is really annoying and can be hard to tell what is going on at first glance.

Associated revisions
2011-05-29 08:59 pm - Eric Davis
[#262] Add a rake task to convert line endings to UNIX

2011-05-29 09:00 pm - Eric Davis
[#262] Convert line endings to UNIX

History
2011-03-05 09:40 pm - Eric Thomas
Pull request here: https://github.com/chiliproject/chiliproject/pull/15

This is definitely one of those things that is subjective to pull in or not. I am always against the "fixing whitespace at end of line" commits since it screws 
up @git blame@ (unless of course you use @-w@ flag. But when I do a fresh clone of a repo, I expect to be at a clean state.

2011-03-05 11:23 pm - Eric Thomas
- Status changed from Open to Ready for review
2011-03-06 07:42 am - Felix Schäfer
I've had several occurrences of funny line endings creeping in in otherwise unrelated lines in commits, so yay from me to include that.

2011-03-07 11:01 pm - Eric Davis
I don't know. This will make merging changes from Redmine difficult if not impossible for some files (they use mixed line endings).

2011-03-07 11:10 pm - Holger Just
Eric Davis wrote:
> I don't know. This will make merging changes from Redmine difficult if not impossible for some files (they use mixed line endings).

This is a bad excuse for allowing bad style. In our code style guide, UNIX line endings are mandatory. I'd rather try to contribute the patch back to 
Redmine. My even Ack pukes on one file somewhere on an UTF-8 error (where I don't know really where), so we should really try to improve 
ChiliProject's code style.

2011-03-07 11:27 pm - Eric Davis
Holger Just wrote:
> This is a bad excuse for allowing bad style.

You're not the one who has to spend hours trying to wade through changes upstream for a merge ;)

What if we fix it on unstable and leave master as it is for now? Master has a higher risk of merge errors for me.

2011-03-20 10:10 am - Felix Schäfer
Eric Davis wrote:
> What if we fix it on unstable and leave master as it is for now? Master has a higher risk of merge errors for me.

I'd say we can pull that for version#5, I'd volunteer to take care of it if everyone agrees on that target.

On a related topic: have we agreed on a style best practice? For example: should empty lines be completely empty or indented to the same level as the 
surrounding code? Hashes currently look @{ :like => this }@ or @{:like => that}@, sometimes they're @{:even => askew }@, what's best practice here? 
And so on.

2011-03-21 11:40 pm - Eric Davis
Felix SchÃ¤fer wrote:
> I'd say we can pull that for version#5, I'd volunteer to take care of it if everyone agrees on that target.

Sure, as long it is after I do the next upstream review (so right before release). We might want to script this into a rake task to catch new files too.

> On a related topic: have we agreed on a style best practice?

In progress [[Code Standards]].

> For example: should empty lines be completely empty or indented to the same level as the surrounding code?

Empty. If @git diff@ will show red/green for trailing whitespace.

> Hashes currently look @{ :like => this }@ or @{:like => that}@, sometimes they're @{:even => askew }@, what's best practice here?

I use @{:key => value, :key => value}@ for single line hashes.
2011-05-20 10:45 pm - Eric Davis
- Target version set to 2.0.0

- Assignee set to Eric Davis

Marking this as 2.0.0 so we make sure to do it.

2011-05-29 07:03 pm - Eric Davis
- Status changed from Ready for review to Closed

I added a rake task (@code:fix_line_endings@) that will go through all of the code and convert them to UNIX line endings using the utility "fromdos" 
(commit:05a4c4616f). Then I ran the conversion on our code (commit:a85b6780d2) and merged the results into unstable.
